<template>
  <div class="ob-multirange">
    <div class="ob-multirange__header">
      <div
        v-for="item in items"
        :key="item.label"
        class="ob-multirange__labels"
      >
        <div class="ob-multirange__label">
          {{ item.startLabel }}
          <div class="ob-multirange__label-value">
            {{ item.start }}
            <span
              v-if="typeof units === 'string'"
              v-html="units"
            />
            <ob-inline-select
              v-else
              v-model="rangeUnit"
              :options="units"
              :data-qa="dataQa"
              @select="changeVal('start', item, index)"
            />
          </div>
        </div>
        <div class="ob-multirange__label">
          {{ item.endLabel }}
          <div class="ob-multirange__label-value">
            {{ item.end }}
            <span
              v-if="typeof units === 'string'"
              v-html="units"
            />
            <ob-inline-select
              v-else
              v-model="rangeUnit"
              :options="units"
              :data-qa="dataQa"
              @select="changeVal('end', item, index)"
            />
          </div>
        </div>
      </div>
    </div>
    <div class="ob-multirange__content">
      <div
        v-for="(item, index) in items"
        :key="`slider-${index}`"
        class="ob-multirange__inputs"
      >
        <div
          :class="['ob-multirange-gap', { 'is-disabled': item.isDisabled }]"
          :style="getGapStyle(item)"
        />
        <input
          v-model.number="item.start"
          type="range"
          :min="startVal"
          :max="endVal"
          :step="item.step || 1"
          :disabled="item.isDisabled || false"
          :data-qa="dataQa"
          @input="changeVal('start', item, index)"
        >
        <input
          v-model.number="item.end"
          type="range"
          :min="startVal"
          :max="endVal"
          :step="item.step || 1"
          :disabled="item.isDisabled || false"
          :data-qa="dataQa"
          @input="changeVal('end', item, index)"
        >
      </div>
    </div>
  </div>
</template>

<script>
import obInlineSelect from './obInlineSelect'

const colorsMap = {
  blue: '##004BC8',
  lavender: '#E5EDF9',
  green: '#0DA577',
  red: '#C6343F',
  yellow: '#E7A031',
  purple: '#8968AE'
}

export default {
  name: 'ObMultiRangeSelect',

  components: {
    obInlineSelect
  },

  props: {
    value: {
      type: Array,
      required: true,
      validator: (value) => {
        const total = value.reduce((acc, item) => {
          return acc + (item.end - item.start)
        }, 0)
        return total < 100
      }
    },
    startVal: {
      type: Number,
      required: false,
      default: 0
    },
    endVal: {
      type: Number,
      required: false,
      default: 100
    },
    units: {
      type: [Array, String],
      required: false
    },
    dataQa: {
      type: String
    }
  },

  data () {
    return {
      items: this.value,
      rangeUnit: {
        label: 'кг',
        uuid: 2
      }
    }
  },

  created () {
    if (typeof this.units !== 'string') {
      this.rangeUnit = this.units[0]
    }
  },

  methods: {
    getGapStyle (item) {
      return {
        left: `${((item.start - this.startVal) / (this.endVal - this.startVal)) * 100}%`,
        right: `${100 - (((item.end - this.startVal) / (this.endVal - this.startVal)) * 100)}%`,
        backgroundColor: colorsMap[item.color] || '#6693DE'
      }
    },

    changeVal (type, item, index) {
      if (type === 'start') {
        const prevRange = index > 0 ? this.items[index - 1] : null
        if (prevRange) {
          if (
            item.start - item.step < prevRange.end &&
            item.start < prevRange.end
          ) {
            item.start = item.start + item.step
          }
          if (item.start < prevRange.end) {
            item.start = prevRange.end
          }
        }
        if (item.start > item.end) {
          item.start = item.end
        }
      }

      if (type === 'end') {
        const nextRange =
          index < this.items.length ? this.items[index + 1] : null
        if (nextRange) {
          if (
            item.end + item.step > nextRange.start &&
            item.end > nextRange.start
          ) {
            item.end = item.end - item.step
          }
          if (item.end > nextRange.start) {
            item.end = nextRange.start
          }
        }
        if (item.end < item.start) {
          item.end = item.start
        }
      }

      const unit = typeof this.units !== 'string' ? this.rangeUnit.label : this.units

      this.$emit(
        'input',
        this.items.map(item => {
          return { start: item.start, end: item.end, unit: unit }
        })
      )
    }
  }
}
</script>

<style lang="scss" scoped>
@import "../../assets/style/ob-style";

@mixin slider-thumbs() {
  pointer-events: all;
  position: relative;
  outline: 0;
  width: 1em;
  height: 1em;
  z-index: 10;
  background: transparent;
  cursor: move;
  border: 0;
}
@mixin slider-tracks() {
  pointer-events: none;
  position: absolute;
  padding: 0;
  margin: 0;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  height: 100%;
  width: 100%;
  outline: none;
  border-radius: 1em;
  background: $lavender;
  border: 0;
}

.ob-multirange {
  width: 100%;
  height: 52px;
  font-size: 12px;
  letter-spacing: 0.4px;
  color: $color-grey-label;
  background-color: $background-white;
  border: 1px solid $very-pale-blue;
  border-bottom: none;
  border-top-left-radius: 3px;
  border-top-right-radius: 3px;
}

.ob-multirange__header {
  display: flex;
  background: white;
}

.ob-multirange__labels {
  flex: 1 0 0;
  display: flex;

  &:not(:only-child):not(:last-child) {
    border-right: 1px solid $very-pale-blue;
  }
}

.ob-multirange__label {
  padding: 6px 12px 9px;
  flex: 1 0 0;
}

.ob-multirange__label-value {
  font-size: 16px;
  color: $cobalt-black;

  span {
    color: $gray-window;
  }
}

.ob-multirange__content {
  position: relative;
  top: -8px;
  height: 10px;
  pointer-events: none;
}

input[type="range"] {
  -webkit-appearance: none;
  -moz-appearance: none;
  font-size: 1em;
  z-index: 1;
  @include slider-tracks();

  &:active,
  &:focus {
    outline: 0;
    z-index: 2;
  }
  &::-moz-focus-outer {
    border: 0;
  }

  &::-webkit-slider-runnable-track {
    margin: 0 -0.5em;
  }
  &::-moz-range-track {
    @include slider-tracks();
  }

  &::-webkit-slider-thumb {
    -webkit-appearance: none;
    @include slider-thumbs();
  }
  &::-moz-range-thumb {
    -moz-appearance: none;
    @include slider-thumbs();
  }

  &:disabled {
    opacity: 0.5;
  }
}

.ob-multirange-gap {
  pointer-events: none;
  position: absolute;
  top: 0;
  bottom: 0;
  z-index: 3;

  &:before {
    content: "";
    width: 4px;
    height: 16px;
    background-color: $light-denim;
    position: absolute;
    left: 0;
    top: -6px;
  }

  &:after {
    content: "";
    width: 4px;
    height: 16px;
    background-color: $light-denim;
    position: absolute;
    right: 0;
    top: -6px;
  }

  span {
    position: absolute;
    left: 50%;
    bottom: calc(100% + 14px);
    transform: translateX(-50%);
  }
}

.ob-multirange__inputs {
  position: absolute;
  width: 100%;
  height: 4px;
  bottom: 0;
}

.is-disabled,
.ob-multirange-gap.is-disabled:before,
.ob-multirange-gap.is-disabled:after {
  background-color: gray !important;
}

.is-disabled input[type="range"]{
  &::-webkit-slider-thumb {
    cursor: text !important;
  }
}

.is-disabled input[type="range"]{
  &::-moz-range-thumb {
    cursor: not-allowed;
  }
}
</style>
